From 702aa41f5830d9fc5408ffeb4b6324afeebf716b Mon Sep 17 00:00:00 2001
From: Stephen Gallagher <sgallagh@redhat.com>
Date: Jan 18 2018 16:36:31 +0000
Subject: [PATCH 5/48] Parse xmd input into GLib.Variants


---

diff --git a/modulemd/__init__.py b/modulemd/__init__.py
index b66fc24..4330b3c 100644
--- a/modulemd/__init__.py
+++ b/modulemd/__init__.py
@@ -613,15 +613,59 @@ class ModuleMetadata(object):
             d[key] = value.unpack()
         return d
 
+    def _variant_str(s):
+        if not isinstance(s, str):
+            raise TypeError ("Only strings are supported for scalars")
+
+        return GLib.Variant('s', s)
+
+    def _variant_list(l):
+        l_variant = list()
+        for item in l:
+            if type(item) == str:
+                l_variant.append(ModuleMetadata._variant_str(item))
+            elif type(item) == list:
+                l_variant.append(ModuleMetadata._variant_list(item))
+            elif type(item) == dict:
+                l_variant.append(ModuleMetadata._variant_dict(item))
+            else:
+                raise TypeError ("Cannot convert unknown type")
+        return GLib.Variant('av', l_variant);
+
+    def _variant_dict_values(d):
+        if not isinstance(d, dict):
+            raise TypeError ("Only dictionaries are supported for mappings")
+
+        d_variant = dict()
+        for k, v in d.items():
+            if type(v) == str:
+                d_variant[k] = ModuleMetadata._variant_str(v);
+                pass
+            elif type(v) == list:
+                d_variant[k] = ModuleMetadata._variant_list(v);
+            elif type(v) == dict:
+                d_variant[k] = ModuleMetadata._variant_dict(v);
+            else:
+                raise TypeError ("Cannot convert unknown type")
+        return d_variant
+
+    def _variant_dict(d):
+        if not isinstance(d, dict):
+            raise TypeError ("Only dictionaries are supported for mappings")
+
+        d_variant = ModuleMetadata._variant_dict_values(d)
+
+        return GLib.Variant('a{sv}', d_variant);
+
+
     @xmd.setter
     def xmd(self, d):
         if not isinstance(d, dict):
             raise TypeError("xmd: data type not supported")
 
-        # TODO: implement this
-        return
+        xmd = ModuleMetadata._variant_dict_values(d)
 
-        self.module.set_xmd(d)
+        self.module.set_xmd(xmd)
 
     @property
     def profiles(self):

